import 'index.dart';

class MaterialGoogleFontSearchInput extends StatefulWidget {
  final InputDecoration inputDecoration;
  final Function confirm;

  MaterialGoogleFontSearchInput({this.confirm, this.inputDecoration});
  @override
  _MaterialGoogleFontSearchInputState createState() =>
      _MaterialGoogleFontSearchInputState();
}

class _MaterialGoogleFontSearchInputState
    extends State<MaterialGoogleFontSearchInput> {
  String currentSearchMatch = "No matches";
  String currentValue = "Search for a better font";
  int threshold = 3;

  _MaterialGoogleFontSearchInputState();

//Search the Google Fonts API

  int searchGoogleFonts(String value) {
    // TODO set up a debounce
    // We are going to call [fonts.google.com] after 3 chars
    // search fonts list to see if we have a match.
    if (value.length > threshold) {
      return MaterialGoogleFontChoosers.fontsList
          .indexWhere((s) => s.contains(value));
    }
    return null;
  }

  updateCurrentSearchMatch(int index) {
    setState(() {
      currentSearchMatch = MaterialGoogleFontChoosers.fontsList[index];
    });
  }

  //Comment this out before release so they have to create thier own confirmation logic. I want ot keep this agnostic

  onChanged(String value) => searchGoogleFonts(value);

  //A basic input widget
  //So you can style it as you need
  input(decoration) => TextField(decoration: decoration, onChanged: onChanged);

  @override
  Widget build(BuildContext context) {
    double width = MediaQuery.of(context).size.width * 0.6;
    return Container(
      width: width,
      child: Column(
        children: <Widget>[
          input(widget.inputDecoration),
          FlatButton(
              child: Text(currentSearchMatch), onPressed: widget.confirm),
        ],
      ),
    );
  }
}

/// A Calculator.
class GoogleFontProvider {
  /// Returns [value] plus 1.
  int addOne(int value) => value + 1;
}
